=== modified file 'drizzled/plugin/storage_engine.cc'
--- drizzled/plugin/storage_engine.cc	2011-01-17 06:41:24 +0000
+++ drizzled/plugin/storage_engine.cc	2011-01-26 06:50:16 +0000
@@ -686,8 +686,8 @@
 
 void StorageEngine::getIdentifiers(Session &session, const identifier::Schema &schema_identifier, identifier::Table::vector &set_of_identifiers)
 {
-  static identifier::Schema INFORMATION_SCHEMA_IDENTIFIER("information_schema");
-  static identifier::Schema DATA_DICTIONARY_IDENTIFIER("data_dictionary");
+  static identifier::Schema INFORMATION_SCHEMA_IDENTIFIER("INFORMATION_SCHEMA");
+  static identifier::Schema DATA_DICTIONARY_IDENTIFIER("DATA_DICTIONARY");
 
   CachedDirectory directory(schema_identifier.getPath(), set_of_table_definition_ext);
 

=== modified file 'plugin/function_engine/function.cc'
--- plugin/function_engine/function.cc	2011-01-17 18:16:53 +0000
+++ plugin/function_engine/function.cc	2011-01-26 08:00:35 +0000
@@ -41,10 +41,10 @@
   data_dictionary_message(new(message::Schema))
 
 {
-  information_message->set_name("information_schema");
+  information_message->set_name(INFORMATION_SCHEMA_IDENTIFIER.getSchemaName());
   data_dictionary_message->set_collation("utf8_general_ci");
 
-  data_dictionary_message->set_name("data_dictionary");
+  data_dictionary_message->set_name(DATA_DICTIONARY_IDENTIFIER.getSchemaName());
   data_dictionary_message->set_collation("utf8_general_ci");
 }
 

=== modified file 'plugin/information_schema_dictionary/tests/r/schemata.result'
--- plugin/information_schema_dictionary/tests/r/schemata.result	2011-01-01 01:13:51 +0000
+++ plugin/information_schema_dictionary/tests/r/schemata.result	2011-01-26 06:50:16 +0000
@@ -1,7 +1,7 @@
 select * from INFORMATION_SCHEMA.SCHEMATA;
 CATALOG_NAME	SCHEMA_NAME	SCHEMA_OWNER	DEFAULT_CHARACTER_SET_CATALOG	DEFAULT_CHARACTER_SET_SCHEMA	DEFAULT_CHARACTER_SET_NAME
-	data_dictionary	NULL	NULL	NULL	NULL
-	information_schema	NULL	NULL	NULL	NULL
+	DATA_DICTIONARY	NULL	NULL	NULL	NULL
+	INFORMATION_SCHEMA	NULL	NULL	NULL	NULL
 LOCAL	mysql	NULL	NULL	NULL	NULL
 LOCAL	test	NULL	NULL	NULL	NULL
 use information_schema;
@@ -13,8 +13,8 @@
 test
 select * from INFORMATION_SCHEMA.SCHEMATA;
 CATALOG_NAME	SCHEMA_NAME	SCHEMA_OWNER	DEFAULT_CHARACTER_SET_CATALOG	DEFAULT_CHARACTER_SET_SCHEMA	DEFAULT_CHARACTER_SET_NAME
-	data_dictionary	NULL	NULL	NULL	NULL
-	information_schema	NULL	NULL	NULL	NULL
+	DATA_DICTIONARY	NULL	NULL	NULL	NULL
+	INFORMATION_SCHEMA	NULL	NULL	NULL	NULL
 LOCAL	mysql	NULL	NULL	NULL	NULL
 LOCAL	test	NULL	NULL	NULL	NULL
 select * from INFORMATION_SCHEMA.SCHEMATA WHERE CATALOG_NAME=NULL;
@@ -29,26 +29,26 @@
 CATALOG_NAME	SCHEMA_NAME	SCHEMA_OWNER	DEFAULT_CHARACTER_SET_CATALOG	DEFAULT_CHARACTER_SET_SCHEMA	DEFAULT_CHARACTER_SET_NAME
 select * from INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME="data_dictionary";
 CATALOG_NAME	SCHEMA_NAME	SCHEMA_OWNER	DEFAULT_CHARACTER_SET_CATALOG	DEFAULT_CHARACTER_SET_SCHEMA	DEFAULT_CHARACTER_SET_NAME
-	data_dictionary	NULL	NULL	NULL	NULL
+	DATA_DICTIONARY	NULL	NULL	NULL	NULL
 select * from INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME="information_schema";
 CATALOG_NAME	SCHEMA_NAME	SCHEMA_OWNER	DEFAULT_CHARACTER_SET_CATALOG	DEFAULT_CHARACTER_SET_SCHEMA	DEFAULT_CHARACTER_SET_NAME
-	information_schema	NULL	NULL	NULL	NULL
+	INFORMATION_SCHEMA	NULL	NULL	NULL	NULL
 select * from INFORMATION_SCHEMA.SCHEMATA ORDER BY SCHEMA_NAME;
 CATALOG_NAME	SCHEMA_NAME	SCHEMA_OWNER	DEFAULT_CHARACTER_SET_CATALOG	DEFAULT_CHARACTER_SET_SCHEMA	DEFAULT_CHARACTER_SET_NAME
-	data_dictionary	NULL	NULL	NULL	NULL
-	information_schema	NULL	NULL	NULL	NULL
+	DATA_DICTIONARY	NULL	NULL	NULL	NULL
+	INFORMATION_SCHEMA	NULL	NULL	NULL	NULL
 LOCAL	mysql	NULL	NULL	NULL	NULL
 LOCAL	test	NULL	NULL	NULL	NULL
 select * from INFORMATION_SCHEMA.SCHEMATA ORDER BY SCHEMA_NAME,CATALOG_NAME;
 CATALOG_NAME	SCHEMA_NAME	SCHEMA_OWNER	DEFAULT_CHARACTER_SET_CATALOG	DEFAULT_CHARACTER_SET_SCHEMA	DEFAULT_CHARACTER_SET_NAME
-	data_dictionary	NULL	NULL	NULL	NULL
-	information_schema	NULL	NULL	NULL	NULL
+	DATA_DICTIONARY	NULL	NULL	NULL	NULL
+	INFORMATION_SCHEMA	NULL	NULL	NULL	NULL
 LOCAL	mysql	NULL	NULL	NULL	NULL
 LOCAL	test	NULL	NULL	NULL	NULL
 select * from INFORMATION_SCHEMA.SCHEMATA ORDER BY CATALOG_NAME,SCHEMA_NAME;
 CATALOG_NAME	SCHEMA_NAME	SCHEMA_OWNER	DEFAULT_CHARACTER_SET_CATALOG	DEFAULT_CHARACTER_SET_SCHEMA	DEFAULT_CHARACTER_SET_NAME
-	data_dictionary	NULL	NULL	NULL	NULL
-	information_schema	NULL	NULL	NULL	NULL
+	DATA_DICTIONARY	NULL	NULL	NULL	NULL
+	INFORMATION_SCHEMA	NULL	NULL	NULL	NULL
 LOCAL	mysql	NULL	NULL	NULL	NULL
 LOCAL	test	NULL	NULL	NULL	NULL
 create schema a;
@@ -66,7 +66,7 @@
 LOCAL	aa	NULL	NULL	NULL	NULL
 SELECT * FROM INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME like "%a";
 CATALOG_NAME	SCHEMA_NAME	SCHEMA_OWNER	DEFAULT_CHARACTER_SET_CATALOG	DEFAULT_CHARACTER_SET_SCHEMA	DEFAULT_CHARACTER_SET_NAME
-	information_schema	NULL	NULL	NULL	NULL
+	INFORMATION_SCHEMA	NULL	NULL	NULL	NULL
 LOCAL	a	NULL	NULL	NULL	NULL
 LOCAL	aa	NULL	NULL	NULL	NULL
 SELECT * FROM INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME like "%s";
@@ -74,8 +74,8 @@
 LOCAL	ds	NULL	NULL	NULL	NULL
 SELECT * FROM INFORMATION_SCHEMA.SCHEMATA;
 CATALOG_NAME	SCHEMA_NAME	SCHEMA_OWNER	DEFAULT_CHARACTER_SET_CATALOG	DEFAULT_CHARACTER_SET_SCHEMA	DEFAULT_CHARACTER_SET_NAME
-	data_dictionary	NULL	NULL	NULL	NULL
-	information_schema	NULL	NULL	NULL	NULL
+	DATA_DICTIONARY	NULL	NULL	NULL	NULL
+	INFORMATION_SCHEMA	NULL	NULL	NULL	NULL
 LOCAL	a	NULL	NULL	NULL	NULL
 LOCAL	aa	NULL	NULL	NULL	NULL
 LOCAL	b	NULL	NULL	NULL	NULL
@@ -91,9 +91,9 @@
 LOCAL	b	NULL	NULL	NULL	NULL
 LOCAL	c	NULL	NULL	NULL	NULL
 LOCAL	d	NULL	NULL	NULL	NULL
-	data_dictionary	NULL	NULL	NULL	NULL
+	DATA_DICTIONARY	NULL	NULL	NULL	NULL
 LOCAL	ds	NULL	NULL	NULL	NULL
-	information_schema	NULL	NULL	NULL	NULL
+	INFORMATION_SCHEMA	NULL	NULL	NULL	NULL
 LOCAL	mysql	NULL	NULL	NULL	NULL
 LOCAL	test	NULL	NULL	NULL	NULL
 drop schema a;

=== modified file 'plugin/information_schema_dictionary/tests/r/tables.result'
--- plugin/information_schema_dictionary/tests/r/tables.result	2011-01-01 01:13:51 +0000
+++ plugin/information_schema_dictionary/tests/r/tables.result	2011-01-26 06:50:16 +0000
@@ -1,7 +1,7 @@
 select * from INFORMATION_SCHEMA.SCHEMATA;
 CATALOG_NAME	SCHEMA_NAME	SCHEMA_OWNER	DEFAULT_CHARACTER_SET_CATALOG	DEFAULT_CHARACTER_SET_SCHEMA	DEFAULT_CHARACTER_SET_NAME
-	data_dictionary	NULL	NULL	NULL	NULL
-	information_schema	NULL	NULL	NULL	NULL
+	DATA_DICTIONARY	NULL	NULL	NULL	NULL
+	INFORMATION_SCHEMA	NULL	NULL	NULL	NULL
 LOCAL	mysql	NULL	NULL	NULL	NULL
 LOCAL	test	NULL	NULL	NULL	NULL
 select * from INFORMATION_SCHEMA.TABLES;

=== modified file 'plugin/schema_dictionary/tests/r/data_dictionary.result'
--- plugin/schema_dictionary/tests/r/data_dictionary.result	2011-01-09 22:15:22 +0000
+++ plugin/schema_dictionary/tests/r/data_dictionary.result	2011-01-26 06:50:16 +0000
@@ -10,8 +10,8 @@
 0
 SELECT SCHEMA_NAME  FROM schemas ORDER BY SCHEMA_NAME;
 SCHEMA_NAME
-data_dictionary
-information_schema
+DATA_DICTIONARY
+INFORMATION_SCHEMA
 mysql
 test
 SELECT COLUMN_NAME  FROM columns;

=== modified file 'plugin/show_dictionary/dictionary.h'
--- plugin/show_dictionary/dictionary.h	2010-10-24 01:20:11 +0000
+++ plugin/show_dictionary/dictionary.h	2011-01-26 06:50:16 +0000
@@ -31,6 +31,8 @@
 #include "drizzled/current_session.h"
 #include "drizzled/message/schema.pb.h"
 
+#include <drizzled/generator.h>
+
 #include "plugin/show_dictionary/show.h"
 
 #include "plugin/show_dictionary/show_columns.h"

=== modified file 'plugin/show_dictionary/show_schemas.cc'
--- plugin/show_dictionary/show_schemas.cc	2011-01-06 21:14:45 +0000
+++ plugin/show_dictionary/show_schemas.cc	2011-01-26 06:50:16 +0000
@@ -32,73 +32,27 @@
 
 ShowSchemas::Generator::Generator(Field **arg) :
   show_dictionary::Show::Generator(arg),
-  is_schema_primed(false)
-{
+  schema_generator(getSession())
+{
+}
+
+bool ShowSchemas::Generator::populate()
+{
+  drizzled::message::schema::shared_ptr schema_ptr;
+
   if (not isShowQuery())
-   return;
-}
-
-/**
-  @note return true if a match occurs.
-*/
-bool ShowSchemas::Generator::checkSchema()
-{
-  if (isWild((*schema_iterator).getSchemaName()))
-    return true;
-
-  return false;
-}
-
-bool ShowSchemas::Generator::nextSchemaCore()
-{
-  if (is_schema_primed)
-  {
-    schema_iterator++;
-  }
-  else
-  {
-    plugin::StorageEngine::getIdentifiers(getSession(), schema_names);
-    schema_iterator= schema_names.begin();
-    is_schema_primed= true;
-  }
-
-  if (schema_iterator == schema_names.end())
     return false;
 
-  if (checkSchema())
-      return false;
-
-  return true;
-}
-  
-bool ShowSchemas::Generator::nextSchema()
-{
-  while (not nextSchemaCore())
-  {
-    if (schema_iterator == schema_names.end())
-      return false;
-  }
-
-  return true;
-}
-
-
-bool ShowSchemas::Generator::populate()
-{
-  if (nextSchema())
-  {
-    fill();
+  while ((schema_ptr= schema_generator))
+  {
+    if (isWild(schema_ptr->name()))
+      continue;
+
+    /* Schema */
+    push(schema_ptr->name());
+
     return true;
   }
 
   return false;
 }
-
-/**
-  A lack of a parsed schema file means we are using defaults.
-*/
-void ShowSchemas::Generator::fill()
-{
-  /* Schema */
-  push((*schema_iterator).getSchemaName());
-}

=== modified file 'plugin/show_dictionary/show_schemas.h'
--- plugin/show_dictionary/show_schemas.h	2011-01-16 19:48:25 +0000
+++ plugin/show_dictionary/show_schemas.h	2011-01-26 06:50:16 +0000
@@ -29,24 +29,13 @@
 
   class Generator : public show_dictionary::Show::Generator 
   {
-    drizzled::identifier::Schema::vector schema_names;
-    drizzled::identifier::Schema::vector::const_iterator schema_iterator;
-
-    bool is_schema_primed;
-
-    virtual void fill();
-    virtual bool checkSchema();
-
   public:
     Generator(drizzled::Field **arg);
 
     bool populate();
-    bool nextSchemaCore();
-    bool nextSchema();
-    bool isSchemaPrimed()
-    {
-      return is_schema_primed;
-    }
+
+  private:
+    drizzled::generator::Schema schema_generator;
   };
 
   Generator *generator(drizzled::Field **arg)

=== modified file 'plugin/simple_user_policy/tests/r/basic.result'
--- plugin/simple_user_policy/tests/r/basic.result	2011-01-06 16:43:31 +0000
+++ plugin/simple_user_policy/tests/r/basic.result	2011-01-26 06:50:16 +0000
@@ -2,8 +2,8 @@
 create schema user2;
 SELECT SCHEMA_NAME FROM DATA_DICTIONARY.SCHEMAS ORDER BY SCHEMA_NAME;
 SCHEMA_NAME
-data_dictionary
-information_schema
+DATA_DICTIONARY
+INFORMATION_SCHEMA
 mysql
 test
 user1
@@ -15,8 +15,8 @@
 ERROR 42S02: Table 'user1.dont_exist' doesn't exist
 SELECT SCHEMA_NAME FROM DATA_DICTIONARY.SCHEMAS ORDER BY SCHEMA_NAME;
 SCHEMA_NAME
-data_dictionary
-information_schema
+DATA_DICTIONARY
+INFORMATION_SCHEMA
 user1
 SELECT * from user2.dont_exist;
 ERROR 42000: Access denied for user 'user1'@'LOCALHOST' to schema 'user2'

=== modified file 'tests/r/data_dictionary_like_info.result'
--- tests/r/data_dictionary_like_info.result	2011-01-18 00:08:34 +0000
+++ tests/r/data_dictionary_like_info.result	2011-01-26 06:50:16 +0000
@@ -326,7 +326,7 @@
 SELECT SCHEMA_NAME FROM DATA_DICTIONARY.SCHEMAS
 WHERE SCHEMA_NAME ='data_dictionary';
 SCHEMA_NAME
-data_dictionary
+DATA_DICTIONARY
 SELECT TABLE_COLLATION FROM DATA_DICTIONARY.TABLES
 WHERE TABLE_SCHEMA='mysql' and TABLE_NAME= 'db';
 TABLE_COLLATION

=== modified file 'tests/r/information_schema.result'
--- tests/r/information_schema.result	2011-01-18 00:08:34 +0000
+++ tests/r/information_schema.result	2011-01-26 06:50:16 +0000
@@ -365,7 +365,7 @@
 SELECT SCHEMA_NAME FROM data_dictionary.schemas
 WHERE SCHEMA_NAME ='data_dictionary';
 SCHEMA_NAME
-data_dictionary
+DATA_DICTIONARY
 SELECT TABLE_COLLATION FROM data_dictionary.tables
 WHERE TABLE_SCHEMA='mysql' and TABLE_NAME= 'db';
 TABLE_COLLATION

